(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/material/input'), require('@angular/material/select'), require('@angular/material/datepicker'), require('@angular/common'), require('@angular/forms'), require('@angular/platform-browser/animations'), require('@angular/platform-browser'), require('@angular/material')) :
    typeof define === 'function' && define.amd ? define('angular-udf', ['exports', '@angular/core', '@angular/material/input', '@angular/material/select', '@angular/material/datepicker', '@angular/common', '@angular/forms', '@angular/platform-browser/animations', '@angular/platform-browser', '@angular/material'], factory) :
    (factory((global['angular-udf'] = {}),global.ng.core,global.ng.material.input,global.ng.material.select,global.ng.material.datepicker,global.ng.common,global.ng.forms,global.ng.platformBrowser.animations,global.ng.platformBrowser,global.ng.material));
}(this, (function (exports,i0,input,select,datepicker,common,forms,animations,platformBrowser,material) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularUdfService = /** @class */ (function () {
        function AngularUdfService() {
        }
        AngularUdfService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        AngularUdfService.ctorParameters = function () { return []; };
        /** @nocollapse */ AngularUdfService.ngInjectableDef = i0.defineInjectable({ factory: function AngularUdfService_Factory() { return new AngularUdfService(); }, token: AngularUdfService, providedIn: "root" });
        return AngularUdfService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularUdfComponent = /** @class */ (function () {
        function AngularUdfComponent(fb) {
            this.fb = fb;
            this.udfFormArray = this.fb.array([]);
        }
        /**
         * @return {?}
         */
        AngularUdfComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.udfFormGroup.addControl('udfFormArray', this.udfFormArray);
                this.udfData.forEach(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) {
                    _this.udfFormArray.push(_this.fb.group(( /** @type {?} */({
                        name: data.custom_field.name,
                        value: data.custom_field.default_value
                    }))));
                }));
            };
        AngularUdfComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'lib-angular-udf',
                        template: "\n    <div [formGroup]=\"udfFormGroup\" class=\"container\">\n      <div formArrayName=\"udfFormArray\">\n        <div *ngFor=\"let group of udfFormArray.controls; let i=index\" [formGroupName]=\"i\" [ngSwitch]=\"udfData[i].custom_field.type\">\n\n          <mat-form-field *ngSwitchCase=\"'TEXT'\" class=\"item-udf\">\n            <input type=\"text\" matInput formControlName=\"value\" placeholder=\"{{group.value.name}}\">\n          </mat-form-field>\n\n          <mat-form-field *ngSwitchCase=\"'NUMBER'\" class=\"item-udf\">\n            <input type=\"number\" matInput formControlName=\"value\" placeholder=\"{{group.value.name}}\">\n          </mat-form-field>\n\n          <mat-form-field *ngSwitchCase=\"'ANY_TEXT'\" class=\"item-udf\"> \n            <textarea matInput formControlName=\"value\" placeholder=\"{{group.value.name}}\"></textarea> \n          </mat-form-field> \n\n          <mat-form-field *ngSwitchCase=\"'LIST_OF_VALUES'\" class=\"item-udf\">\n            <mat-select formControlName=\"value\" placeholder=\"{{group.value.name}}\">\n              <mat-option *ngFor=\"let option of udfData[i].custom_field.options\" [value]=\"option\" for=\"option\">\n                {{option}}\n              </mat-option>\n            </mat-select>\n          </mat-form-field>\n\n          <mat-slide-toggle *ngSwitchCase=\"'YES_OR_NO'\" color=\"primary\" formControlName=\"value\" class=\"item-udf\">\n            {{group.value.name}}\n          </mat-slide-toggle>\n        \n          <mat-form-field *ngSwitchCase=\"'DATE'\" appearance=\"outline\" class=\"item-udf\">\n            <input matInput [matDatepicker]=\"picker\" placeholder=\"{{group.value.name}}\" formControlName=\"value\"  autocomplete=\"off\">\n            <mat-datepicker-toggle matSuffix [for]=\"picker\"></mat-datepicker-toggle>\n            <mat-datepicker touchUi #picker></mat-datepicker>\n          </mat-form-field>\n\n        </div>\n      </div>\n    </div>\n  ",
                        styles: [".container{display:flex;flex-direction:column;width:100%}.item-udf{width:100%}mat-slide-toggle{margin:10px}.example-margin{margin:0 10px}"]
                    }] }
        ];
        /** @nocollapse */
        AngularUdfComponent.ctorParameters = function () {
            return [
                { type: forms.FormBuilder }
            ];
        };
        AngularUdfComponent.propDecorators = {
            udfData: [{ type: i0.Input }],
            udfFormGroup: [{ type: i0.Input }]
        };
        return AngularUdfComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularUdfModule = /** @class */ (function () {
        function AngularUdfModule() {
        }
        AngularUdfModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [AngularUdfComponent],
                        imports: [
                            input.MatInputModule,
                            select.MatSelectModule,
                            datepicker.MatDatepickerModule,
                            material.MatSlideToggleModule,
                            material.MatNativeDateModule,
                            material.MatAutocompleteModule,
                            material.MatChipsModule,
                            material.MatIconModule,
                            material.MatMenuModule,
                            common.CommonModule,
                            forms.ReactiveFormsModule,
                            animations.BrowserAnimationsModule,
                            platformBrowser.BrowserModule,
                        ],
                        exports: [AngularUdfComponent]
                    },] }
        ];
        return AngularUdfModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.AngularUdfService = AngularUdfService;
    exports.AngularUdfComponent = AngularUdfComponent;
    exports.AngularUdfModule = AngularUdfModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=angular-udf.umd.js.map