import { Injectable, NgModule, Component, Input, defineInjectable } from '@angular/core';
import { MatInputModule } from '@angular/material/input';
import { MatSelectModule } from '@angular/material/select';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { CommonModule } from '@angular/common';
import { FormBuilder, ReactiveFormsModule } from '@angular/forms';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { BrowserModule } from '@angular/platform-browser';
import { MatSlideToggleModule, MatNativeDateModule, MatAutocompleteModule, MatChipsModule, MatIconModule, MatMenuModule } from '@angular/material';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AngularUdfService {
    constructor() { }
}
AngularUdfService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
AngularUdfService.ctorParameters = () => [];
/** @nocollapse */ AngularUdfService.ngInjectableDef = defineInjectable({ factory: function AngularUdfService_Factory() { return new AngularUdfService(); }, token: AngularUdfService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AngularUdfComponent {
    /**
     * @param {?} fb
     */
    constructor(fb) {
        this.fb = fb;
        this.udfFormArray = this.fb.array([]);
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.udfFormGroup.addControl('udfFormArray', this.udfFormArray);
        this.udfData.forEach((/**
         * @param {?} data
         * @return {?}
         */
        (data) => {
            this.udfFormArray.push(this.fb.group((/** @type {?} */ ({
                name: data.custom_field.name,
                value: data.custom_field.default_value
            }))));
        }));
    }
}
AngularUdfComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-angular-udf',
                template: `
    <div [formGroup]="udfFormGroup" class="container">
      <div formArrayName="udfFormArray">
        <div *ngFor="let group of udfFormArray.controls; let i=index" [formGroupName]="i" [ngSwitch]="udfData[i].custom_field.type">

          <mat-form-field *ngSwitchCase="'TEXT'" class="item-udf">
            <input type="text" matInput formControlName="value" placeholder="{{group.value.name}}">
          </mat-form-field>

          <mat-form-field *ngSwitchCase="'NUMBER'" class="item-udf">
            <input type="number" matInput formControlName="value" placeholder="{{group.value.name}}">
          </mat-form-field>

          <mat-form-field *ngSwitchCase="'ANY_TEXT'" class="item-udf"> 
            <textarea matInput formControlName="value" placeholder="{{group.value.name}}"></textarea> 
          </mat-form-field> 

          <mat-form-field *ngSwitchCase="'LIST_OF_VALUES'" class="item-udf">
            <mat-select formControlName="value" placeholder="{{group.value.name}}">
              <mat-option *ngFor="let option of udfData[i].custom_field.options" [value]="option" for="option">
                {{option}}
              </mat-option>
            </mat-select>
          </mat-form-field>

          <mat-slide-toggle *ngSwitchCase="'YES_OR_NO'" color="primary" formControlName="value" class="item-udf">
            {{group.value.name}}
          </mat-slide-toggle>
        
          <mat-form-field *ngSwitchCase="'DATE'" appearance="outline" class="item-udf">
            <input matInput [matDatepicker]="picker" placeholder="{{group.value.name}}" formControlName="value"  autocomplete="off">
            <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
            <mat-datepicker touchUi #picker></mat-datepicker>
          </mat-form-field>

        </div>
      </div>
    </div>
  `,
                styles: [".container{display:flex;flex-direction:column;width:100%}.item-udf{width:100%}mat-slide-toggle{margin:10px}.example-margin{margin:0 10px}"]
            }] }
];
/** @nocollapse */
AngularUdfComponent.ctorParameters = () => [
    { type: FormBuilder }
];
AngularUdfComponent.propDecorators = {
    udfData: [{ type: Input }],
    udfFormGroup: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class AngularUdfModule {
}
AngularUdfModule.decorators = [
    { type: NgModule, args: [{
                declarations: [AngularUdfComponent],
                imports: [
                    MatInputModule,
                    MatSelectModule,
                    MatDatepickerModule,
                    MatSlideToggleModule,
                    MatNativeDateModule,
                    MatAutocompleteModule,
                    MatChipsModule,
                    MatIconModule,
                    MatMenuModule,
                    CommonModule,
                    ReactiveFormsModule,
                    BrowserAnimationsModule,
                    BrowserModule,
                ],
                exports: [AngularUdfComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AngularUdfService, AngularUdfComponent, AngularUdfModule };

//# sourceMappingURL=angular-udf.js.map